#include "MyChannel.h"

#include "../MyPuls/MyPuls.h"


//______________________________________________________________________________________________________________________
MyChannel::~MyChannel()
{
	//delete all to this channel attached pulses//
	for (int i=0;i<pulses.size();++i) 
		delete pulses[i];
}

//______________________________________________________________________________________________________________________
MyPuls* MyChannel::addPuls()
{
	//--if we have the same number of pulses than the vector contains we need to increase the vector
	if ( nbrPulses >= pulses.size() )
	{
		//resize the vector//
		pulses.resize( pulses.size() + 10 );
		//allocate the pointers in the vector 
		for (int i=nbrPulses;i<pulses.size();++i)
			pulses[i] = new MyPuls(this);
	}

	//increase number of pulses by one
	++nbrPulses;
	//return the last element
	return pulses[nbrPulses -1];
}

//______________________________________________________________________________________________________________________
void MyChannel::copyRawData(char *in, size_t length)
{
	//copy the array to the rawdata array//
	//resize the data array if necessary and add some additional memory//
	if (rawLengthBuffer < length*parentEvent->getNbrBytes())
	{
		delete rawdata;
		rawLengthBuffer = length*parentEvent->getNbrBytes() + 1024;
		rawdata = new char[rawLengthBuffer];
	}
	memcpy(rawdata,in,length*parentEvent->getNbrBytes());
	rawLength=length;
}

//______________________________________________________________________________________________________________________
void MyChannel::clear()
{
	//go through all Pulses and clear them//
	for (int i=0;i<nbrPulses;++i)
		pulses[i]->clear();
	//set the currently used pulses to 0//
	nbrPulses = 0;
}