#ifndef __MyChannel_h__
#define __MyChannel_h__

#include <vector>

class MyEvent;
class MyPuls;

class MyChannel 
{
public:
	MyChannel():
	  parentEvent(0),
	  nbrPulses(0),
	  rawdata(0),
	  rawLength(0),
	  rawLengthBuffer(0)	{}

	MyChannel(MyEvent *pe):
	  parentEvent(pe),
	  nbrPulses(0),
	  rawdata(0),
	  rawLength(0),
	  rawLengthBuffer(0)	{}
	~MyChannel();

protected:
	MyChannel& operator=(const MyChannel& in)	{return *this;}
	MyChannel(const MyChannel& in)				{}

public:
	void clear();
	MyPuls * addPuls();
	MyPuls* getPuls(long index)					{return (nbrPulses)?pulses[index]:0;}
	short getNbrPulses() const					{return nbrPulses;}

	short  getBaseline() const					{return baseline;}
	void   setBaseline(short in)				{baseline = in;}
	short  getNoise() const						{return noise;}
	void   setNoise(short in)					{noise = in;}
	short  getFullScale()const 					{return fullscale;}
	void   setFullScale(short in)				{fullscale=in;}
	short  getOffset() const					{return offset;}
	void   setOffset(short in)					{offset=in;}
	double getVertGain()const 					{return gain;}
	void   setVertGain(double in)				{gain=in;}
	long   getStepSize() const					{return stsi;}
	void   setStepSize(long in)					{stsi = in;}
	long   getBackSize() const					{return bs;}
	void   setBackSize(long in)					{bs = in;}
	long   getChannelNbr() const				{return chNbr;}
	void   setChannelNbr(long in)				{chNbr = in;}
	void   copyRawData(char * in, size_t length);
	void*  getRawData() const					{return rawdata;}
	void   setRawDataLength(size_t in)			{rawLength = in;}
	size_t getRawDataLength() const				{return rawLength;}

	MyEvent* getParentEvent()					{return parentEvent;}


private:
	//these variables could go into a header//	
	short fullscale;					//the fullscale for this channel (in mV)
	short offset;						//the offset for this channel (in mV)
	double gain;						//the conversion factor from adc bytes to mV (adc bytes * gain = mV)
	short baseline;						//the baseline for this channel (in adc bytes)
	short noise;						//the noiselevel for this channel (in adc bytes)
	long stsi;							//the stepsize for this channel
	long bs;							//the backsize for this channel
	long chNbr;							//the channel number of this channel

	//these don't need to be recorded//
	char *rawdata;						//!pointer to the raw data
	size_t rawLengthBuffer;				//!length of the raw databuffer
	size_t rawLength;					//!length of the raw data in data type units

	//only the nbrPulses need to be written into the tree//
	//not the whole vector//
	size_t nbrPulses;					//nbr of Pulses this channel currently has
	std::vector<MyPuls*> pulses;		//Container stores a lot of pulses

	MyEvent * parentEvent;				//pointer to the event that this channel belong to
};
#endif
