#include "MyEvent.h"

#include "../MyChannel/MyChannel.h"

//______________________________________________________________________________________________________________________
MyEvent::MyEvent(size_t nChans)
{
	nbrChannels = nChans;
	channels.resize(nbrChannels);
	for (int i=0;i<channels.size();++i)
	{
		channels[i] = new MyChannel(this);
		channels[i]->setChannelNbr(i+1);
	}
}


//______________________________________________________________________________________________________________________
MyEvent::~MyEvent()
{
	for (int i=0;i<channels.size();++i) 
		delete channels[i];
}

//______________________________________________________________________________________________________________________
void MyEvent::clear()
{
	//--go through the whole vector an clear the elements--//
	//--but only if the channel was recorded before--//
	for (int i=0; i<channels.size();++i)
		if (usedChans & (0x1<<i))
			channels[i]->clear();
}
