#ifndef __MyEvent_h__
#define __MyEvent_h__

#include <vector>

class MyChannel;
class MyPuls;

class MyEvent 
{
public:
	MyEvent()								{}
	MyEvent(size_t nChans);
	~MyEvent();

protected:
	MyEvent& operator=(const MyEvent& in)	{return *this;}
	MyEvent(const MyEvent& in)				{}

public:
	void clear();
	MyChannel* getChannel(long index)		{return (nbrChannels)?channels[index]:0;}
	short getNbrOfChannels() const			{return nbrChannels;}

	long getEventID() const					{return EventID;}
	double getHorpos() const				{return horpos;}
	void  setNbrBytes(size_t in)			{nbrBytes=in;}
	short getNbrBytes() const				{return nbrBytes;}
	double getSampleInterval() const		{return sampInter;}
	void   setSampleInterval(double in)		{sampInter=in;}
	long getNbrSamples() const				{return nbrSamples;}
	void setNbrSamples(long in) 			{nbrSamples=in;}
	double getDelayTime() const				{return delayTime;}
	short getTriggerChannel() const			{return TrigChan;}
	double getTriggerLevel() const			{return TrigLevel;}
	short getTriggerSlope() const			{return TrigSlope;}
	long getUsedChannels() const			{return usedChans;}
	long getChanCombUsedChannels() const	{return ChanCombUsedChans;}
	short getNbrConvPerChans() const		{return nbrConPerCh;}

private:
	//these variables need to be stored for each event//
	Long64_t EventID;						//an id for this event. It is just the time the event was recorded
	double horpos;							//the horpos value for this event
	
	short nbrChannels;						//nbr of Channels in this event
	std::vector<MyChannel*> channels;		//vector of Pointers to MyChannel

	//these variables could go into a header//	
	short nbrBytes;							//nbr of bits of the adc values (either 8 or 16)
	double sampInter;						//the time between two consecutive points (in ns)
	long nbrSamples;						//nbr of Points (multiplied by the sampInter it will give the timewindow in ns)
	double delayTime;						//the delay of the trigger with respect to the window
	short TrigChan;							//the Triggering Channel
	double TrigLevel;						//the trigger Level from the Offset
	short TrigSlope;						//which Slope was used by the Trigger
	long usedChans;							//Bitmask discribing which Channels have been recorded 
	long ChanCombUsedChans;					//Bitmask discribing which Converters per Channel have been used
	short nbrConPerCh;						//tells how many converts per channel have been used
};

#endif