#ifndef __MyPuls_h__
#define __MyPuls_h__

#include <TArrayC.h>

#include "../MyEvent/MyEvent.h"
#include "../MyChannel/MyChannel.h"

class MyPuls 
{
public:
	MyPuls():
		parentChannel(0),
		idxFiP(0)		{}

	MyPuls(MyChannel* pc):
		parentChannel(pc),
		idxFiP(0)		{}

	~MyPuls()			{data.fArray=0; data.fN=0;}

protected:
	MyPuls& operator=(const MyPuls& in)		{return *this;}
	MyPuls(const MyPuls& in)				{}

public:
	void setIndexToFirstPoint(long in)		{idxFiP=in;}
	long getIndexToFirstPoint()	const		{return idxFiP;}
	void appendLength(long in)				{data.fN += (in*(parentChannel->getParentEvent()->getNbrBytes()));}
	long getLength() const					{return (data.fN/(parentChannel->getParentEvent()->getNbrBytes()));}
	void setData(char* in)					{data.fArray = in;}
	char* getData() const					{return data.fArray;}
	void clear()							{data.fArray=0;data.fN=0;}

	MyChannel* getParentChannel()			{return parentChannel;}


private:
	TArrayC data;				//array holding the relevant Data from the original Trace
	long idxFiP;				//index to first point in the whole trace in units of the original data type

	MyChannel* parentChannel;	//pointer to the channel that this puls belongs to
};
#endif